# spec file to build the LDAPExplorerTool RPM package
%define name       LDAPExplorerTool
%define version    0.6
%define release    1
%define prefix     /usr
%define sysconfdir /etc

# This stuff makes things install into the directories that LFS wants.
%{expand:%%define share %(if [ -d %{prefix}/share/man ]; then echo /share ; else echo %%{nil} ; fi)}
%ifos linux
%define CONFIG_FLAGS --prefix=%prefix --infodir='%{prefix}%{share}/info' --mandir='%{prefix}%{share}/man'
%else
%define CONFIG_FLAGS --prefix=%prefix
%endif

Summary:    A free multi-platform LDAP client
Name:       %{name}
Version:    %{version}
Release:    %{release}
License:    BSD
Group:      Applications/Internet
Vendor:     None
Url:        http://ldaptool.sf.net/
Source:     %{name}-%{version}.tar.gz
Packager:   Bertrand Lorentz <bertrand.lorentz@free.fr>
Prefix: 	%{prefix}
BuildRoot:  %{_tmppath}/%{name}-%{version}-root
Requires:   openldap >= 2.0.0, wxGTK >= 2.4.0

%description
LDAP Explorer Tool is a free LDAP client, that enables the user to manage LDAP
directories.
With this tool you can view, edit or delete any entry of the LDAP server. You
can also manage the schema, export and import entries using the LDIF format.
LDAP Explorer aims to run on mutliple platforms like Windows, Linux, Solaris, 
Mac OS X...
But for now it has only been tested on Windows and Linux. You're welcome to try
to build and run LDAP Explorer Tool on other platforms. Please give us your
feedback at ldaptool-devel@lists.sourceforge.net.

%prep
%setup

%build
CFLAGS="$RPM_OPT_FLAGS" ./configure %{CONFIG_FLAGS}
make

%install
if [ -d $RPM_BUILD_ROOT ]; then rm -r $RPM_BUILD_ROOT; fi;
make DESTDIR=$RPM_BUILD_ROOT prefix=%{prefix} sysconfdir=%{sysconfdir} install

%files
%doc %{prefix}/share/doc/%{name}/UserGuide/*.html
%doc %{prefix}/share/doc/%{name}/images/*.png
%doc %{prefix}/share/doc/%{name}/README 
%doc %{prefix}/share/doc/%{name}/COPYING
%doc %{prefix}/share/doc/%{name}/AUTHORS
%doc %{prefix}/share/doc/%{name}/ChangeLog
%doc %{prefix}/share/doc/%{name}/INSTALL
%doc %{prefix}/share/doc/%{name}/NEWS
%doc %{prefix}/share/doc/%{name}/TODO

%{prefix}/share/locale/*/*/*
%{prefix}/share/LDAPExplorerTool

%{prefix}/bin/LDAPExplorerTool

%clean
rm -r $RPM_BUILD_ROOT

%changelog

* Sat Oct 18 2003 Bertrand Lorentz <bertrand.lorentz@free.fr>
- Fix the path to the doc files.

* Sat Apr 12 2003 Bertrand Lorentz <bertrand.lorentz@free.fr>
- Initial spec file release.
