// DynamicBuffer.h: interface for the DynamicBuffer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DYNAMICBUFFER_H__6A2CDCD3_94A2_481E_9109_5C39D4101A8D__INCLUDED_)
#define AFX_DYNAMICBUFFER_H__6A2CDCD3_94A2_481E_9109_5C39D4101A8D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "LDAPBrowser_Defines.h"	// Added by ClassView

#define DYN_BUFFER_SIZE			2048
#define DYN_BUFFER_INCREMENT	2048

class DynamicBuffer  
{
public:
	wxString substr( unsigned long p_Pos1, unsigned long p_Pos2 ) const ;
	wxString substr( unsigned long p_Pos1 ) const ;
	unsigned long npos() const ;
	unsigned long find( unsigned char p_Char ) const ;
	unsigned long size( void ) const ;
	void append( char c );
	unsigned long length( void ) const ;
	void Reset( void );
	const char * c_str() const ;
	DynamicBuffer( unsigned long p_Size = DYN_BUFFER_SIZE, 
		unsigned long p_Increment = DYN_BUFFER_INCREMENT );
	DynamicBuffer( const DynamicBuffer & p_Copy );
	DynamicBuffer( const wxString & p_Str );
	const DynamicBuffer & operator=( const DynamicBuffer & p_Copy );
	virtual ~DynamicBuffer();
	//char	operator[]( unsigned long p_Pos );
	unsigned char operator[]( unsigned long p_Pos ) const ;
	
private:
	bool increase( void );
	unsigned long m_Increment;
	unsigned long m_Size;
	unsigned long m_Pos;
	unsigned char * m_Buffer;
};


#endif // !defined(AFX_DYNAMICBUFFER_H__6A2CDCD3_94A2_481E_9109_5C39D4101A8D__INCLUDED_)
