// LB_BinaryDlg.h: interface for the LB_BinaryDlg class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LB_BINARYDLG_H__056F30D8_25B2_4B9A_B0D3_5727C7F1DB92__INCLUDED_)
#define AFX_LB_BINARYDLG_H__056F30D8_25B2_4B9A_B0D3_5727C7F1DB92__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <ldap.h>
#include <wx/grid.h>

class MyGridTable : public wxGridTableBase
{
public :
	MyGridTable( berval * p_Value )
	{
		m_Value = p_Value ;
		m_RealLen = p_Value->bv_len ;
	}
	int GetNumberRows()
	{
		long Rows = m_Value->bv_len / 80 ;
		long X = m_Value->bv_len % 80 ;
		if( X > 0 )
		{
			Rows ++ ;
		}
		return Rows;
	}
	int GetNumberCols()
	{
		return 80;
	}
	bool IsEmptyCell( int p_Row, int p_Col )
	{
		unsigned long Pos = p_Row * 80 + p_Col ;
		if( Pos > m_RealLen )
		{
			return true;
		}
		return false;
	}
	wxString GetValue( int p_Row, int p_Col )
	{
		wxString Ret;
		unsigned long Pos = p_Row * 80 + p_Col ;
		Ret.Printf( wxT("%.2X"), ( unsigned char ) m_Value->bv_val[ Pos ] );
		return Ret;
	}
	void SetValue( int p_Row, int p_Col, const wxString & p_Val )
	{
		unsigned long Pos = p_Row * 80 + p_Col ;
		unsigned long added_len ;
		if( Pos > m_Value->bv_len )
		{
			added_len = Pos - m_Value->bv_len ;
			if( added_len < 100 )
			{
				added_len = 100 ;
			}
			char *Save = m_Value->bv_val;
			m_Value->bv_val = new char[ m_Value->bv_len + added_len ];
			if( m_Value->bv_val == NULL )
			{
				m_Value->bv_val = Save ;
				return ;
			}
			memcpy( m_Value->bv_val, Save, m_Value->bv_len );
			
			memset( m_Value->bv_val + m_Value->bv_len + 1, 0, added_len );

			m_Value->bv_len = m_Value->bv_len + added_len ;
			m_RealLen = Pos ;	
			delete []Save ;
		}
		long	NewVal ;
		if( p_Val == wxT("") )
		{
			m_RealLen = Pos - 1 ;
		}
		else
		{
			p_Val.ToLong( &NewVal, 16 );
			m_Value->bv_val[ Pos ] = NewVal ;
		}		
	}
	void SetValueLength( void )
	{
		m_Value->bv_len = m_RealLen ;
	}
	bool AppendRows( size_t numRows = 1 )
	{
		return true;
	}
	~MyGridTable()
	{
	}
protected:
	berval *m_Value ;
	unsigned long m_RealLen ;
};


class LB_BinaryCtrl : public wxGrid
{
public:
	void SetValueLength();
	LB_BinaryCtrl( wxWindow *p_Parent, berval *p_Value );
	~LB_BinaryCtrl();
protected:
	MyGridTable *m_Table;
	
	DECLARE_EVENT_TABLE()

};

class LB_BinaryDlg : public wxDialog  
{
public:
	void OnPaint( wxPaintEvent &p_Evt );
	void OnButtonCancel( wxCommandEvent &p_Evt );
	void OnButtonAdd( wxCommandEvent &p_Evt );
	void OnOk( wxCommandEvent &p_Evt );
	LB_BinaryDlg( wxWindow * p_Parent, berval *p_Value );
	virtual ~LB_BinaryDlg();


protected:
	DECLARE_EVENT_TABLE()

};

#endif // !defined(AFX_LB_BINARYDLG_H__056F30D8_25B2_4B9A_B0D3_5727C7F1DB92__INCLUDED_)
