/*! 
 *********************************************************************
 *  @file   : LDAPBrowser_Defines.h
 *
 *  Project : LDAP Explorer
 *
 *  Package : LDAP
 *
 *  Company : <<>>
 *
 *  Author  : Laurent Ulrich                              Date: 10/11/2002
 *
 *  Purpose : Declaration of class LDAPBrowser_Defines
 *
 *********************************************************************
 */

#if !defined(AFX_NAPALM_DEFINES_H__406E42C4_B0E4_422C_B3C7_898D072B19C6__INCLUDED_)
#define AFX_NAPALM_DEFINES_H__406E42C4_B0E4_422C_B3C7_898D072B19C6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <wx/log.h>
#include <string>
#include <vector>

/* Name of package */
#ifndef PACKAGE
#define PACKAGE "LDAPExplorerTool"
#endif

/* Version number of package */
#ifndef VERSION
#define VERSION "0.6"
#endif


#define USE_GENERIC_TBAR 0
#define USE_XPM_BITMAPS 1

#if USE_GENERIC_TBAR
    #if !wxUSE_TOOLBAR_SIMPLE
        #error wxToolBarSimple is not compiled in, set wxUSE_TOOLBAR_SIMPLE \
               to 1 in setup.h and recompile the library.
    #else
        #include <wx/tbarsmpl.h>
    #endif
#endif // USE_GENERIC_TBAR

#if USE_XPM_BITMAPS && defined(__WXMSW__) && !wxUSE_XPM_IN_MSW
    #error You need to enable XPM support to use XPM bitmaps with toolbar!
#endif // USE_XPM_BITMAPS



#define _PROJECT_NAME		"LDAP Explorer Tool"

#define ULONG	unsigned long

typedef std::vector< wxString >						StringVector;

typedef enum USED_IDS
{
	/*
	ID_BUTTON1 = 0,
	ID_BUTTON2,
	ID_BUTTON3,
	ID_BUTTON4,
	ID_BUTTON5,
	ID_BUTTON6,
	ID_CHOICE1,
	ID_CHOICE2,
	ID_NOTEBOOK,
	ID_PANEL1,
	ID_PANEL2,
	ID_LISTBOX1,
	ID_LISTBOX2
	*/
}__USED_IDS;


#define LOG_MESSAGE( arg )					::wxLogMessage( arg )
#define LOG_MESSAGE_ARG( arg1 , arg2 )		::wxLogMessage( arg1, arg2 )
#define MSGBOX_ARG( arg1 , arg2 )			::wxLogMessage( arg1, arg2 )

#ifdef HAVE_STRNCASECMP
#define strnicmp(a,b,c)   strncasecmp((a),(b),(c))
#endif

#ifdef HAVE_STRCASECMP
#define stricmp(a,b)   strcasecmp((a),(b))
#endif

class LDAPBrowser_Defines  
{
public:
	LDAPBrowser_Defines();
	virtual ~LDAPBrowser_Defines();

};


#define STR_MSG_SEARCH_NO_RESULT	_( "No entry found" )
#define STR_MSG_SEARCH_TITLE		_( "Search result" )
#define STR_MSG_SEARCH_ROOT_ENTRY	_( "<results>" )

#define	MAX_BINARY_PRINT			1024
#define wxLANGUAGE_ELSASSICH  wxLANGUAGE_USER_DEFINED + 1

#ifdef __WXMSW__
	#define DEFAULT_WXRCDIR				"Res"
	#define DEFAULT_ART					"Res"
#endif


typedef enum LDAP_SERVER_TYPE
{
	OPENLDAP = 1, 
	NOVELL = 2, 
	NETSCAPE = 3
}; 
extern char					*LDAP_Server_TypeNames[] ;
extern LDAP_SERVER_TYPE		LDAP_Server_Types[] ;

#endif // !defined(AFX_NAPALM_DEFINES_H__406E42C4_B0E4_422C_B3C7_898D072B19C6__INCLUDED_)
