/*! 
 *********************************************************************
 *  @file   : LDAPBrowser_LeftPane.h
 *
 *  Project : LDAP Explorer
 *
 *  Package : LDAP
 *
 *  Company : <<>>
 *
 *  Author  : Laurent Ulrich                              Date: 10/11/2002
 *
 *  Purpose : Declaration of class LDAPBrowser_LeftPane
 *
 *********************************************************************
 */

#if !defined(AFX_NAPALM_LEFTPANE_H__E717DB88_45B9_4910_8BD6_C11E11BBCE49__INCLUDED_)
#define AFX_NAPALM_LEFTPANE_H__E717DB88_45B9_4910_8BD6_C11E11BBCE49__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <wx/treectrl.h>

class LDAPBrowser_LeftPane : public wxTreeCtrl  
{
public:
	int			m_IsSearchResult;
	wxString	m_Base;
	wxString	m_Request;

	void OnSearch( wxMenuEvent &p_Evt );
	void OnSelectionChanged( wxTreeEvent &p_Evt );
	void OnPopupRefresh( wxMenuEvent &p_Evt );
	void OnPopupDelete( wxMenuEvent &p_Evt );
	void OnPopupAdd( wxMenuEvent &p_Evt );
	void OnPopupModify( wxMenuEvent &p_Evt );
	void OnPopupMove( wxMenuEvent &p_Evt );
	void OnRightMouseClick( wxMouseEvent &p_Evt );
	void OnItemActivated( wxTreeEvent &p_Evt );
	LDAPBrowser_LeftPane( wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxTR_HAS_BUTTONS, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("listCtrl") );
	virtual ~LDAPBrowser_LeftPane();

protected:
	wxImageList	*m_TreeStdImageList;
	wxImageList	*m_TreeStateImageList;

	void OnItemCollapsed( wxTreeEvent &p_Event );
	void OnItemExpanded( wxTreeEvent &p_Event );

	DECLARE_EVENT_TABLE()
};

#endif // !defined(AFX_NAPALM_LEFTPANE_H__E717DB88_45B9_4910_8BD6_C11E11BBCE49__INCLUDED_)
