/*! 
 *********************************************************************
 *  @file   : LDAPBrowser_MainFrame.h
 *
 *  Project : LDAP Explorer
 *
 *  Package : LDAP
 *
 *  Company : <<>>
 *
 *  Author  : Laurent Ulrich                              Date: 10/11/2002
 *
 *  Purpose : Declaration of class LDAPBrowser_MainFrame
 *
 *********************************************************************
 */

#if !defined(AFX_LDAPBROWSER_MAINFRAME_H__7C6375E3_810B_4324_8A90_B4D30A5D2A44__INCLUDED_)
#define AFX_LDAPBROWSER_MAINFRAME_H__7C6375E3_810B_4324_8A90_B4D30A5D2A44__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
class LDAPBrowser_LeftPane;
class LDAPBrowser_RightPane;
class LDAPBrowser_About;
class LDAP_Schema;

#include <wx/frame.h>
#include <wx/treectrl.h>
#include <wx/splitter.h>

#include "LDAP_Class.h"
#include "LDAP_Schema.h"

class LDAPBrowser_MainFrame : public wxFrame  
{
	friend class LDAPBrowser_RightPane ;
	friend class LDAPBrowser_LeftPane;
public:
	void OnEditPreferences(wxMenuEvent &p_Evt);
	void OnFileExportBinAttribute(wxMenuEvent &p_Evt);
	void OnFileAddBinAttribute(wxMenuEvent &p_Evt);
	void OnFileDelBinAttribute(wxMenuEvent &p_Evt);
	void OnFileViewBinAttribute(wxMenuEvent &p_Evt);
	void OnFileMovDNEntry(wxMenuEvent &p_Evt);
	void OnFileModAttribute( wxMenuEvent & p_Evt );
	void OnFileDelAttribute( wxMenuEvent &p_Evt );
	void OnFileAddAttribute( wxMenuEvent &p_Event );
	void OnFileModDNEntry( wxMenuEvent &p_Evt );
	void OnFileDelEntry( wxMenuEvent &p_Evt );
	void OnFileAddEntry( wxMenuEvent &p_Evt );
	void OnImport(wxMenuEvent &p_Event);
	LDAP_Schema * GetSchema();
	void OnAbout( wxMenuEvent &p_Event );
	void OnNew( wxMenuEvent & p_Evt );
	void OnExport( wxMenuEvent & p_Event );
	void OnSearchClick( wxMenuEvent & p_Evt );
	wxString GetDN( wxTreeItemId & p_Id );
	void OnSearch( wxTreeItemId & p_Id , const wxString & p_SearchString );
	void OnItemSelected( wxTreeItemId & p_Id );
	int OnDeleteEntry( wxTreeItemId & p_Id );
	void OnNewEntry( wxTreeItemId & p_Id );

	void SetSizeLimit( int SizeLimit );

	int OnSave( wxMenuEvent &p_Evt );
	
	void					OnCloseWindow( wxCloseEvent & event );
	void					OnOpen( wxMenuEvent &event );
	void					OnItemActivated(wxTreeItemId &p_Id);

							LDAPBrowser_MainFrame( wxWindow * p_Parent , long p_ID , const wxString & p_WindowName );
	virtual					~LDAPBrowser_MainFrame();
protected:
	void					ShowItemAttributes( wxTreeItemId & p_Id );
	void					DrawToolBar();
	int						Initialize();
	int						CreateMenuBar();

	LDAPBrowser_LeftPane	*m_LeftPane ;
	LDAPBrowser_RightPane	*m_RightPane ;
	LDAPBrowser_About		*m_AboutDialog ;
	wxToolBar				*m_ToolBar ;
	wxSplitterWindow		*m_Splitter;
	float					m_Percent;
	int						m_DataLoaded ;
	long					m_ID;

	LDAP_Class				m_LDAP;
	LDAP_Schema				m_Schema;


	DECLARE_EVENT_TABLE()
};

#endif // !defined(AFX_LDAPBROWSER_MAINFRAME_H__7C6375E3_810B_4324_8A90_B4D30A5D2A44__INCLUDED_)
