/*! 
 *********************************************************************
 *  @file   : LDAPBrowser_OpenDialog.h
 *
 *  Project : LDAP Explorer
 *
 *  Package : LDAP
 *
 *  Company : <<>>
 *
 *  Author  : Laurent Ulrich                              Date: 19/11/2002
 *
 *  Purpose : Declaration of class LDAPBrowser_OpenDialog
 *
 *********************************************************************
 */

#if !defined(AFX_LDAPBROWSER_OPENDIALOG_H__1A3DB3F3_EF55_41EC_938A_1F9B2035BF4E__INCLUDED_)
#define AFX_LDAPBROWSER_OPENDIALOG_H__1A3DB3F3_EF55_41EC_938A_1F9B2035BF4E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <wx/dialog.h>
#include "LDAPBrowser_Defines.h"	// Added by ClassView

class LDAPBrowser_OpenDialog : public wxDialog  
{
public:
	void UpdateUI();
	void OnDeleteConfig( wxCommandEvent &event );
	void OnNewConfig( wxCommandEvent & event );
	void OnSelect( wxEvent & p_Evt );
	void OnOk( wxCommandEvent &event );
	void OnCancel(wxCommandEvent &event );
	LDAPBrowser_OpenDialog( wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_DIALOG_STYLE, const wxString& name = wxT("dialogBox") );
	virtual ~LDAPBrowser_OpenDialog();
	wxString			m_StrServer;
	wxString			m_StrPort;
	wxString			m_StrBaseDN;
	wxString			m_StrUser;
	wxString			m_StrPassword;
	wxString			m_StrConfig;
	LDAP_SERVER_TYPE	m_SrvType;
protected:
	LDAP_SERVER_TYPE	GetType( const wxString & p_ServerType );
	int					GetTypeNameIndex( LDAP_SERVER_TYPE p_Type );

	wxChoice		*m_Configuration;
	wxTextCtrl		*m_Server;
	wxTextCtrl		*m_Port;
	wxTextCtrl		*m_RootDN;
	wxTextCtrl		*m_User;
	wxTextCtrl		*m_Password;
	wxChoice		*m_ServerType ;
	
	DECLARE_EVENT_TABLE()
	
};

#endif // !defined(AFX_LDAPBROWSER_OPENDIALOG_H__1A3DB3F3_EF55_41EC_938A_1F9B2035BF4E__INCLUDED_)
