/*! 
 *********************************************************************
 *  @file   : LDAPBrowser_RightPane.h
 *
 *  Project : LDAP Explorer
 *
 *  Package : LDAP
 *
 *  Company : <<>>
 *
 *  Author  : Laurent Ulrich                              Date: 19/11/2002
 *
 *  Purpose : Declaration of class LDAPBrowser_RightPane
 *
 *********************************************************************
 */

#if !defined(AFX_NAPALM_RIGHTPANE_H__25031DB9_8907_4202_AD00_9AE937A4A6AC__INCLUDED_)
#define AFX_NAPALM_RIGHTPANE_H__25031DB9_8907_4202_AD00_9AE937A4A6AC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <ldap.h>

#include <wx/treectrl.h>

#include "LDAP_Class.h"

class LDAPBrowser_RightPane : public wxTreeCtrl  
{
	friend class LDAPBrowser_MainFrame;
public:
	void OnPopupExportBin( wxMenuEvent &p_Evt );
	void OnPopupViewBin( wxMenuEvent &p_Evt );
	void OnPopupAddBin( wxMenuEvent &p_Evt );
	void Expand( void );
	int AddRootItem( const wxString &p_RootDN );
	int UIAddAttributeValue( const wxString &p_Name, const wxString &p_Value, bool p_IsNew );
	int UIAddAttributeValue( const wxTreeItemId &p_ParentID, const wxString &p_Value, bool p_IsNew );
	int UIAddAttribute(const wxString &p_Name, StringVector &p_Values, bool p_IsNew);
	wxString GetDN();
	void SetDN( const wxString &p_DN );
	void EmptyPane( bool p_DeleteUI = true );
	void IsNew( bool p_IsNew );
	bool IsNew();
	void IsModified( bool p_State, bool p_CheckEmptyAtt );
	bool IsModified();
	int	OnSave();
	void OnPopupSave( wxMenuEvent & p_Evt );
	void OnPopupDelete( wxMenuEvent & p_Evt );
	void OnPopupAdd( wxMenuEvent & p_Evt );
	void OnPopupModify( wxMenuEvent & p_Evt );
	LDAPBrowser_RightPane(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxLC_ICON, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxT("listCtrl") );
	virtual ~LDAPBrowser_RightPane();


	
protected:
	void						EmptyMods();
	long						GetAttributeIndex( wxTreeItemId &p_Id );
	void						OnBeginEdit( wxTreeEvent & p_Evt );
	void						OnEndEdit( wxTreeEvent & p_Evt );
	void						OnRightMouseClick( wxMouseEvent & p_Evt );
	void						OnPopupDelBin(wxMenuEvent &p_Evt);
	int							BinaryValueOp( long p_Op, const wxString &p_Attribute, berval * p_Value );
	int							UIGetAttributeName( wxString & p_AttributeName );
	int							Mods_AddAttribute( int p_Op, const wxString &p_Name, 
									StringVector &p_Values );

	CSTL_ModsVector				m_Mods ;
	bool						m_IsNew;
	wxString					m_DN ;
	
	DECLARE_EVENT_TABLE()
};

#endif // !defined(AFX_NAPALM_RIGHTPANE_H__25031DB9_8907_4202_AD00_9AE937A4A6AC__INCLUDED_)
