/*! Time-stamp: <@(#)LDAP_Schema.h   11/02/2003 - 08:41:03   Laurent Ulrich>
 *********************************************************************
 *  @file   : LDAP_Schema.h
 *
 *  Project : LDAPExplorer
 *
 *  Package : LDAP
 *
 *  Company : <<>>
 *
 *  Author  : Laurent Ulrich                              Date: 11/02/2003
 *
 *  Purpose : Declaration of class LDAP_Schema
 *
 *********************************************************************
 */

#if !defined(AFX_LDAP_SCHEMA_H__0A9867F3_C741_4DC3_8112_E81F6FB19755__INCLUDED_)
#define AFX_LDAP_SCHEMA_H__0A9867F3_C741_4DC3_8112_E81F6FB19755__INCLUDED_

#include "LDAP_Class.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define ATTRIBUTE_TYPE_ALL		3
#define ATTRIBUTE_TYPE_MAY		2
#define ATTRIBUTE_TYPE_MUST		1

class LDAP_Schema : public LDAP_Class
{
public:
	StringVector GetSupValues(const wxString &p_Str);
	StringVector GetMAYMUSTValues( const wxString &p_Str );
	StringVector GetObjectClassAttributes( const wxString & p_ObjectClass, short p_Which );
	StringVector GetObjectClasses();
	bool IsOpen();
	int OpenSchema();
	LDAP_Schema();
	virtual ~LDAP_Schema();

	wxString			SchemaEntry ;
	wxString			VendorName;
	wxString			VendorVersion;
	
	StringVector		namingContexts ;
	StringVector		supportedLDAPVersion;
	StringVector		dsaName;
	StringVector		DirectoryTreeName;
	
protected:
	wxString			ExtractAttribute( const wxString & p_Line, 
							const wxString & p_AttributeName, 
							const wxString & p_Separator );
	StringVector		GetNameValues( const wxString & p_Str );

	bool						m_IsOpen ;
};

#endif // !defined(AFX_LDAP_SCHEMA_H__0A9867F3_C741_4DC3_8112_E81F6FB19755__INCLUDED_)
