#ifndef LB_UTILS_H
#define LB_UTILS_H

#define IS_UTF8_1( p_Str, index ) ( p_Str[ index ] ) >= 0x80 && ( p_Str[ index ] ) <= 0xBF

#define IS_UTF8_2( p_Str, index, len )\
	( index + 1 ) < len && ( p_Str[ index ] ) >= 0xC0 && ( p_Str[ index ] ) <= 0xDF && \
	IS_UTF8_1( p_Str, ++index )  

#define IS_UTF8_3( p_Str, index, len )\
	( index + 2 ) < len && ( p_Str[ index ] ) >= 0xE0 && ( p_Str[ index ] ) <= 0xEF && \
	IS_UTF8_1( p_Str, ++index ) && IS_UTF8_1( p_Str, ++index ) 

#define IS_UTF8_4( p_Str, index, len )\
	( index + 3 ) < len && ( p_Str[ index ] ) >= 0xF0 && ( p_Str[ index ] ) <= 0xF7 && \
	IS_UTF8_1( p_Str, ++index ) && IS_UTF8_1( p_Str, ++index ) && IS_UTF8_1( p_Str, ++index ) 

#define IS_UTF8_5( p_Str, index, len )\
	( index + 4 ) < len && ( p_Str[ index ] ) >= 0xF8 && ( p_Str[ index ] ) <= 0xFB && \
	IS_UTF8_1( p_Str, ++index ) && IS_UTF8_1( p_Str, ++index ) && IS_UTF8_1( p_Str, ++index ) &&\
	IS_UTF8_1( p_Str, ++index )

#define IS_UTF8_6( p_Str, index, len )\
	( index + 5 ) < len && ( p_Str[ index ] ) >= 0xFC && ( p_Str[ index ] ) <= 0xFD && \
	IS_UTF8_1( p_Str, ++index ) && IS_UTF8_1( p_Str, ++index ) && IS_UTF8_1( p_Str, ++index ) &&\
	IS_UTF8_1( p_Str, ++index ) && IS_UTF8_1( p_Str, ++index )


extern char	NOT_SAFE_INIT_CHARS[]	;
extern char	NOT_SAFE_CHARS[]		;


bool IsSafeChar( const unsigned char *p_Str, long p_Len, bool p_CheckUTF );
int	ToBinaryPrint( const char *p_Value, unsigned long p_Size, wxString & p_PrintableString );
#endif
