/*! 
 *********************************************************************
 *  @file   : LB_ArtProvider.cpp
 *
 *  Project : LDAP Explorer
 *
 *  Package : LDAP
 *
 *  Company : <<>>
 *
 *  Author  : Laurent Ulrich                              Date: 17/03/2003
 *
 *  Purpose : Implementation of methods for class LB_ArtProvider
 *
 *********************************************************************
 */

#include <wx/wxprec.h>
#ifdef __BORLANDC__
  #pragma hdrstop
#endif

#include <wx/intl.h>
#include <wx/artprov.h>
#include <wx/utils.h>

#include "../include/LDAPBrowser_Defines.h"
#include "../include/LB_ArtProvider.h"

#include "../Res/icon_openedfolder.xpm"
#include "../Res/icon_closedfolder.xpm"

LB_ArtProvider::LB_ArtProvider()
{

}

LB_ArtProvider::~LB_ArtProvider()
{

}

wxBitmap LB_ArtProvider::CreateBitmap(const wxArtID &id, const wxArtClient &client, const wxSize &size)
{
	if( client != wxART_OTHER )
	{
		return wxNullBitmap;
	}
	if( id == wxART_LB_OPENED_FOLDER )
	{
		return icon_openedfolder;
	}
	else if( id == wxART_LB_CLOSED_FOLDER )
	{
		return icon_closedfolder;
	}

	return wxNullBitmap;
	
}

//DEL bool LB_ArtProvider::Load(const wxString &p_Path)
//DEL {
//DEL 	m_Path = p_Path;
//DEL 	return true;
//DEL }
