#include <wx/wxprec.h>
#ifdef __BORLANDC__
  #pragma hdrstop
#endif
#include <wx/grid.h>
#include <wx/intl.h>
#include <wx/dialog.h>
#include <wx/button.h>
#include <wx/icon.h>
#include <wx/sizer.h>
#include <wx/textctrl.h>
#include <wx/xrc/xmlres.h>

#include <string>
#include <vector>

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "../include/LDAPBrowser_Defines.h"
#include "../include/LB_BinaryDlg.h"

BEGIN_EVENT_TABLE( LB_BinaryCtrl, wxGrid )
END_EVENT_TABLE()

BEGIN_EVENT_TABLE( LB_BinaryDlg, wxDialog )

EVT_BUTTON( XRCID( "button_add_row" ), LB_BinaryDlg::OnButtonAdd )
EVT_BUTTON( XRCID( "binary_view_button_cancel" ), LB_BinaryDlg::OnButtonCancel )
END_EVENT_TABLE()

LB_BinaryCtrl::LB_BinaryCtrl( wxWindow *p_Parent, berval *p_Value ) 
			: wxGrid( p_Parent, -1 )
{
	SetSize( wxSize( 300, 100 ) );
	m_Table = new MyGridTable( p_Value );

	SetTable( m_Table, TRUE );
	SetColLabelSize( 0 );
	SetRowLabelSize( 0 );
	
	long i;
	for( i = 0; i < m_Table->GetNumberCols(); i++ )
	{
		SetColMinimalWidth( i, 30 );
		SetColSize( i, 30 );
	}
	for( i = 0; i < m_Table->GetNumberRows(); i++ )
	{
		
	}
}

LB_BinaryCtrl::~LB_BinaryCtrl()
{
}




LB_BinaryDlg::LB_BinaryDlg( wxWindow * p_Parent, berval *p_Buffer ) 
{
	wxXmlResource::Get()->LoadDialog( this, p_Parent, wxT("binary_view_dialog") );

	SetIcon( wxIcon( wxT("AAAAAAAAA") ) );
	CenterOnParent();
	
	wxButton *Bt = ( wxButton * )FindWindowByName( wxT("binary_view_button_cancel"), this );
	wxTextCtrl *Ctrl = ( wxTextCtrl * )FindWindowByName( wxT("binary_view_control"), this );
	if( Ctrl == NULL || Bt == NULL )
	{
		return ;
	}
	Bt->SetFocus();
	
	wxString Buf;
	wxString curr;
	
	for( unsigned long i = 0; i < p_Buffer->bv_len; i++ )
	{
		curr.Printf( wxT("%.2X."), (unsigned char)p_Buffer->bv_val[ i ] );
		Buf += curr;
	}
	Ctrl->SetValue( Buf );
}

LB_BinaryDlg::~LB_BinaryDlg()
{

}


void LB_BinaryDlg::OnOk( wxCommandEvent &p_Evt )
{
	EndModal( wxID_OK );
}

void LB_BinaryDlg::OnButtonAdd( wxCommandEvent &p_Evt )
{
}

void LB_BinaryDlg::OnButtonCancel( wxCommandEvent &p_Evt )
{
	EndModal( wxID_CANCEL );
}

void LB_BinaryCtrl::SetValueLength()
{
}

void LB_BinaryDlg::OnPaint( wxPaintEvent &p_Evt )
{

}
