/*! 
 *********************************************************************
 *  @file   : LDAPBrowser_About.cpp
 *
 *  Project : LDAP Explorer
 *
 *  Package : LDAP
 *
 *  Company : <<>>
 *
 *  Author  : Laurent Ulrich                              Date: 17/03/2003
 *
 *  Purpose : Implementation of methods for class LDAPBrowser_About
 *
 *********************************************************************
 */

#include <wx/wxprec.h>
#ifdef __BORLANDC__
  #pragma hdrstop
#endif

#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/intl.h>
#include <wx/xrc/xmlres.h>

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <vector>
#include "../include/LDAPBrowser_Defines.h"
#include "../include/LDAPBrowser_About.h"

wxString Developpers = wxT("\n    B. Lorentz\n    L. Ulrich");

wxString Copyright[] = { 
wxT("Copyright (c) 2002, Laurent Ulrich"),
wxT("All rights reserved."),
wxT(""),
wxT("Redistribution and use in source and binary forms, with or without modification, are permitted "),
wxT("provided that the following conditions are met:"),
wxT(""),
wxT("-Redistributions of source code must retain the above copyright notice, "),
wxT("this list of conditions and the following disclaimer. "),
wxT(""),
wxT("-Redistributions in binary form must reproduce the above copyright notice, "),
wxT("this list of conditions and the following disclaimer in the documentation and/or "),
wxT("other materials provided with the distribution. "),
wxT(""),
wxT("-Neither the name of the \"LDAP Explorer Tool\" nor the names of its contributors may be "),
wxT("used to endorse or promote products derived from this software without specific "),
wxT("prior written permission. "),
wxT(""),
wxT("THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "),
wxT("\"AS IS\" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT "),
wxT("LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR "),
wxT("A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER "),
wxT("OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, "),
wxT("EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF "),
wxT("SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) "),
wxT("HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, "),
wxT("OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF "),
wxT("THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."), wxT("EOF") };

BEGIN_EVENT_TABLE( LDAPBrowser_About, wxDialog )
	EVT_BUTTON( XRCID( "button_about_dialog_ok" ), LDAPBrowser_About::OnOk )
END_EVENT_TABLE()       

LDAPBrowser_About::LDAPBrowser_About( wxWindow * p_Parent ) 
/*					: wxDialog( p_Parent, -1, wxString( _( "About" ) ), wxDefaultPosition,
					wxDefaultSize, wxDEFAULT_DIALOG_STYLE )*/
{
	/* The follwing line is commented out because it causes a crash on Linux */
//	SetIcon( wxIcon( "AAAAAAAAA" ) );

	wxStaticText	*Dev;
	wxStaticText	*Version;
	wxStaticText	*Package;
	wxTextCtrl		*License;
	wxString		VersionString;
	wxString		DeveloppersString;

	wxXmlResource::Get()->LoadDialog( this, p_Parent, wxT("about_dialog") );
	VersionString = _( "Version : " );
	VersionString += wxT(VERSION);

	DeveloppersString = _( "Developpers : " );
	DeveloppersString += Developpers;

	Package = ( wxStaticText * )FindWindowByName( wxT("about_dialog_product"), this );
	Version = ( wxStaticText * )FindWindowByName( wxT("about_dialog_version"), this );
	Dev = ( wxStaticText * )FindWindowByName( wxT("about_dialog_devs"), this );
	License = ( wxTextCtrl * )FindWindowByName( wxT("about_dialog_licence"), this );
	
	if ( Package )
		Package->SetLabel( wxT(PACKAGE) );
	if ( Version )
		Version->SetLabel( VersionString );
	if ( Dev )
		Dev->SetLabel( DeveloppersString );
	if ( License )
	{
		for( long i = 0; Copyright[i] != wxT("EOF"); i++ )
		{
			License->AppendText( Copyright[i] );
			License->AppendText( wxT("\n") );
		}
	}
}

LDAPBrowser_About::~LDAPBrowser_About()
{

}

void LDAPBrowser_About::OnOk( wxCommandEvent &p_Evt )
{
	SetReturnCode( wxID_OK );
	Show( FALSE );
}
